Index: branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Views/SolverView.Designer.cs
===================================================================
--- branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Views/SolverView.Designer.cs	(revision 13757)
+++ branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Views/SolverView.Designer.cs	(revision 13759)
@@ -60,4 +60,7 @@
       WeifenLuo.WinFormsUI.Docking.TabGradient tabGradient6 = new WeifenLuo.WinFormsUI.Docking.TabGradient();
       WeifenLuo.WinFormsUI.Docking.TabGradient tabGradient7 = new WeifenLuo.WinFormsUI.Docking.TabGradient();
+      this.minTargetView = new HeuristicLab.Data.Views.StringConvertibleValueView();
+      this.maxEvaluationsView = new HeuristicLab.Data.Views.StringConvertibleValueView();
+      this.algorithmCloneButton = new System.Windows.Forms.Button();
       this.seedingStrategyPanel = new System.Windows.Forms.Panel();
       this.solverTabControl = new HeuristicLab.MainForm.WindowsForms.DragOverTabControl();
@@ -67,4 +70,6 @@
       this.runsTabPage = new System.Windows.Forms.TabPage();
       this.runsView = new HeuristicLab.Optimization.Views.RunCollectionView();
+      this.seededRunsTabPage = new System.Windows.Forms.TabPage();
+      this.seededRunsView = new HeuristicLab.Optimization.Views.RunCollectionView();
       this.solutionSeedingTabPage = new System.Windows.Forms.TabPage();
       this.parametersTabPage = new System.Windows.Forms.TabPage();
@@ -73,19 +78,49 @@
       this.operatorGraphViewHost = new HeuristicLab.MainForm.WindowsForms.ViewHost();
       this.algorithmStartButton = new System.Windows.Forms.Button();
-      this.label1 = new System.Windows.Forms.Label();
+      this.minimumTargetLabel = new System.Windows.Forms.Label();
+      this.seedingStrategyLabel = new System.Windows.Forms.Label();
       this.evaluationsLimitabel = new System.Windows.Forms.Label();
       this.algorithmSuggestionLabel = new System.Windows.Forms.Label();
       this.suggestedInstancesComboBox = new System.Windows.Forms.ComboBox();
-      this.algorithmCloneButton = new System.Windows.Forms.Button();
-      this.maxEvaluationsView = new HeuristicLab.Data.Views.StringConvertibleValueView();
-      this.seededRunsTabPage = new System.Windows.Forms.TabPage();
-      this.seededRunsView = new HeuristicLab.Optimization.Views.RunCollectionView();
       this.solverTabControl.SuspendLayout();
       this.resultsTabPage.SuspendLayout();
       this.runsTabPage.SuspendLayout();
+      this.seededRunsTabPage.SuspendLayout();
       this.parametersTabPage.SuspendLayout();
       this.operatorGraphTabPage.SuspendLayout();
-      this.seededRunsTabPage.SuspendLayout();
       this.SuspendLayout();
+      // 
+      // minTargetView
+      // 
+      this.minTargetView.Caption = "StringConvertibleValue View";
+      this.minTargetView.Content = null;
+      this.minTargetView.LabelVisible = false;
+      this.minTargetView.Location = new System.Drawing.Point(431, 3);
+      this.minTargetView.Name = "minTargetView";
+      this.minTargetView.ReadOnly = false;
+      this.minTargetView.Size = new System.Drawing.Size(255, 21);
+      this.minTargetView.TabIndex = 16;
+      // 
+      // maxEvaluationsView
+      // 
+      this.maxEvaluationsView.Caption = "StringConvertibleValue View";
+      this.maxEvaluationsView.Content = null;
+      this.maxEvaluationsView.LabelVisible = false;
+      this.maxEvaluationsView.Location = new System.Drawing.Point(91, 3);
+      this.maxEvaluationsView.Name = "maxEvaluationsView";
+      this.maxEvaluationsView.ReadOnly = false;
+      this.maxEvaluationsView.Size = new System.Drawing.Size(255, 21);
+      this.maxEvaluationsView.TabIndex = 16;
+      // 
+      // algorithmCloneButton
+      // 
+      this.algorithmCloneButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
+      this.algorithmCloneButton.Location = new System.Drawing.Point(823, 56);
+      this.algorithmCloneButton.Name = "algorithmCloneButton";
+      this.algorithmCloneButton.Size = new System.Drawing.Size(26, 23);
+      this.algorithmCloneButton.TabIndex = 15;
+      this.algorithmCloneButton.Text = "Clone";
+      this.algorithmCloneButton.UseVisualStyleBackColor = true;
+      this.algorithmCloneButton.Click += new System.EventHandler(this.AlgorithmCloneButtonOnClick);
       // 
       // seedingStrategyPanel
@@ -217,4 +252,26 @@
       this.runsView.TabIndex = 0;
       // 
+      // seededRunsTabPage
+      // 
+      this.seededRunsTabPage.Controls.Add(this.seededRunsView);
+      this.seededRunsTabPage.Location = new System.Drawing.Point(4, 22);
+      this.seededRunsTabPage.Name = "seededRunsTabPage";
+      this.seededRunsTabPage.Padding = new System.Windows.Forms.Padding(3);
+      this.seededRunsTabPage.Size = new System.Drawing.Size(841, 454);
+      this.seededRunsTabPage.TabIndex = 5;
+      this.seededRunsTabPage.Text = "Seeded Runs";
+      this.seededRunsTabPage.UseVisualStyleBackColor = true;
+      // 
+      // seededRunsView
+      // 
+      this.seededRunsView.Caption = "RunCollection View";
+      this.seededRunsView.Content = null;
+      this.seededRunsView.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.seededRunsView.Location = new System.Drawing.Point(3, 3);
+      this.seededRunsView.Name = "seededRunsView";
+      this.seededRunsView.ReadOnly = false;
+      this.seededRunsView.Size = new System.Drawing.Size(835, 448);
+      this.seededRunsView.TabIndex = 1;
+      // 
       // solutionSeedingTabPage
       // 
@@ -287,12 +344,21 @@
       this.algorithmStartButton.Click += new System.EventHandler(this.AlgorithmStartButtonOnClick);
       // 
-      // label1
-      // 
-      this.label1.AutoSize = true;
-      this.label1.Location = new System.Drawing.Point(3, 33);
-      this.label1.Name = "label1";
-      this.label1.Size = new System.Drawing.Size(91, 13);
-      this.label1.TabIndex = 8;
-      this.label1.Text = "Seeding Strategy:";
+      // minimumTargetLabel
+      // 
+      this.minimumTargetLabel.AutoSize = true;
+      this.minimumTargetLabel.Location = new System.Drawing.Point(384, 6);
+      this.minimumTargetLabel.Name = "minimumTargetLabel";
+      this.minimumTargetLabel.Size = new System.Drawing.Size(41, 13);
+      this.minimumTargetLabel.TabIndex = 13;
+      this.minimumTargetLabel.Text = "Target:";
+      // 
+      // seedingStrategyLabel
+      // 
+      this.seedingStrategyLabel.AutoSize = true;
+      this.seedingStrategyLabel.Location = new System.Drawing.Point(3, 33);
+      this.seedingStrategyLabel.Name = "seedingStrategyLabel";
+      this.seedingStrategyLabel.Size = new System.Drawing.Size(91, 13);
+      this.seedingStrategyLabel.TabIndex = 8;
+      this.seedingStrategyLabel.Text = "Seeding Strategy:";
       // 
       // evaluationsLimitabel
@@ -326,54 +392,9 @@
       this.suggestedInstancesComboBox.SelectedIndexChanged += new System.EventHandler(this.SuggestedInstancesComboBoxOnSelectedIndexChanged);
       // 
-      // algorithmCloneButton
-      // 
-      this.algorithmCloneButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
-      this.algorithmCloneButton.Location = new System.Drawing.Point(823, 56);
-      this.algorithmCloneButton.Name = "algorithmCloneButton";
-      this.algorithmCloneButton.Size = new System.Drawing.Size(26, 23);
-      this.algorithmCloneButton.TabIndex = 15;
-      this.algorithmCloneButton.Text = "Clone";
-      this.algorithmCloneButton.UseVisualStyleBackColor = true;
-      this.algorithmCloneButton.Click += new System.EventHandler(this.AlgorithmCloneButtonOnClick);
-      // 
-      // maxEvaluationsView
-      // 
-      this.maxEvaluationsView.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
-            | System.Windows.Forms.AnchorStyles.Right)));
-      this.maxEvaluationsView.Caption = "StringConvertibleValue View";
-      this.maxEvaluationsView.Content = null;
-      this.maxEvaluationsView.LabelVisible = false;
-      this.maxEvaluationsView.Location = new System.Drawing.Point(91, 3);
-      this.maxEvaluationsView.Name = "maxEvaluationsView";
-      this.maxEvaluationsView.ReadOnly = false;
-      this.maxEvaluationsView.Size = new System.Drawing.Size(758, 21);
-      this.maxEvaluationsView.TabIndex = 16;
-      // 
-      // seededRunsTabPage
-      // 
-      this.seededRunsTabPage.Controls.Add(this.seededRunsView);
-      this.seededRunsTabPage.Location = new System.Drawing.Point(4, 22);
-      this.seededRunsTabPage.Name = "seededRunsTabPage";
-      this.seededRunsTabPage.Padding = new System.Windows.Forms.Padding(3);
-      this.seededRunsTabPage.Size = new System.Drawing.Size(841, 454);
-      this.seededRunsTabPage.TabIndex = 5;
-      this.seededRunsTabPage.Text = "Seeded Runs";
-      this.seededRunsTabPage.UseVisualStyleBackColor = true;
-      // 
-      // seededRunsView
-      // 
-      this.seededRunsView.Caption = "RunCollection View";
-      this.seededRunsView.Content = null;
-      this.seededRunsView.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.seededRunsView.Location = new System.Drawing.Point(3, 3);
-      this.seededRunsView.Name = "seededRunsView";
-      this.seededRunsView.ReadOnly = false;
-      this.seededRunsView.Size = new System.Drawing.Size(835, 448);
-      this.seededRunsView.TabIndex = 1;
-      // 
       // SolverView
       // 
       this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.Controls.Add(this.minTargetView);
       this.Controls.Add(this.maxEvaluationsView);
       this.Controls.Add(this.algorithmCloneButton);
@@ -381,5 +402,6 @@
       this.Controls.Add(this.solverTabControl);
       this.Controls.Add(this.algorithmStartButton);
-      this.Controls.Add(this.label1);
+      this.Controls.Add(this.minimumTargetLabel);
+      this.Controls.Add(this.seedingStrategyLabel);
       this.Controls.Add(this.evaluationsLimitabel);
       this.Controls.Add(this.algorithmSuggestionLabel);
@@ -391,7 +413,7 @@
       this.resultsTabPage.PerformLayout();
       this.runsTabPage.ResumeLayout(false);
+      this.seededRunsTabPage.ResumeLayout(false);
       this.parametersTabPage.ResumeLayout(false);
       this.operatorGraphTabPage.ResumeLayout(false);
-      this.seededRunsTabPage.ResumeLayout(false);
       this.ResumeLayout(false);
       this.PerformLayout();
@@ -410,5 +432,5 @@
     private MainForm.WindowsForms.ViewHost operatorGraphViewHost;
     private System.Windows.Forms.Button algorithmStartButton;
-    private System.Windows.Forms.Label label1;
+    private System.Windows.Forms.Label seedingStrategyLabel;
     private System.Windows.Forms.Label evaluationsLimitabel;
     private System.Windows.Forms.Label algorithmSuggestionLabel;
@@ -422,4 +444,6 @@
     private System.Windows.Forms.TabPage seededRunsTabPage;
     private Optimization.Views.RunCollectionView seededRunsView;
+    private System.Windows.Forms.Label minimumTargetLabel;
+    private Data.Views.StringConvertibleValueView minTargetView;
   }
 }
Index: branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Views/SolverView.cs
===================================================================
--- branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Views/SolverView.cs	(revision 13757)
+++ branches/PerformanceComparison/HeuristicLab.OptimizationExpertSystem/3.3/Views/SolverView.cs	(revision 13759)
@@ -60,4 +60,5 @@
         if (Content == null) {
           maxEvaluationsView.Content = null;
+          minTargetView.Content = null;
           solverParametersView.Content = null;
           runsView.Content = null;
@@ -67,4 +68,5 @@
         } else {
           maxEvaluationsView.Content = Content.MaximumEvaluations;
+          minTargetView.Content = Content.MinimumTarget;
           runsView.Content = Content.InstanceRuns;
           seededRunsView.Content = Content.SeededRuns;