Index: /trunk/sources/HeuristicLab.Problems.DataAnalysis.Views/3.4/Regression/RegressionSolutionScatterPlotView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.DataAnalysis.Views/3.4/Regression/RegressionSolutionScatterPlotView.cs	(revision 13763)
+++ /trunk/sources/HeuristicLab.Problems.DataAnalysis.Views/3.4/Regression/RegressionSolutionScatterPlotView.cs	(revision 13764)
@@ -26,4 +26,5 @@
 using HeuristicLab.MainForm;
 using HeuristicLab.MainForm.WindowsForms;
+using HeuristicLab.Visualization.ChartControlsExtensions;
 
 namespace HeuristicLab.Problems.DataAnalysis.Views {
@@ -156,17 +157,13 @@
         double min = Content.EstimatedTrainingValues.Concat(Content.EstimatedTestValues.Concat(Content.EstimatedValues.Concat(dataset.GetDoubleValues(targetVariableName)))).Min();
 
-        max = max + 0.2 * Math.Abs(max);
-        min = min - 0.2 * Math.Abs(min);
-
-        double interestingValuesRange = max - min;
-        int digits = Math.Max(0, 3 - (int)Math.Log10(interestingValuesRange));
-
-        max = Math.Round(max, digits);
-        min = Math.Round(min, digits);
-
-        this.chart.ChartAreas[0].AxisX.Maximum = max;
-        this.chart.ChartAreas[0].AxisX.Minimum = min;
-        this.chart.ChartAreas[0].AxisY.Maximum = max;
-        this.chart.ChartAreas[0].AxisY.Minimum = min;
+        double axisMin, axisMax, axisInterval;
+        ChartUtil.CalculateAxisInterval(min, max, 5, out axisMin, out axisMax, out axisInterval);
+        this.chart.ChartAreas[0].AxisX.Maximum = axisMax;
+        this.chart.ChartAreas[0].AxisX.Minimum = axisMin;
+        this.chart.ChartAreas[0].AxisX.Interval = axisInterval;
+        this.chart.ChartAreas[0].AxisY.Maximum = axisMax;
+        this.chart.ChartAreas[0].AxisY.Minimum = axisMin;
+        this.chart.ChartAreas[0].AxisY.Interval = axisInterval;
+
         UpdateCursorInterval();
       }
Index: /trunk/sources/HeuristicLab.Visualization.ChartControlsExtensions/3.3/ChartUtil.cs
===================================================================
--- /trunk/sources/HeuristicLab.Visualization.ChartControlsExtensions/3.3/ChartUtil.cs	(revision 13764)
+++ /trunk/sources/HeuristicLab.Visualization.ChartControlsExtensions/3.3/ChartUtil.cs	(revision 13764)
@@ -0,0 +1,74 @@
+﻿#region License Information
+
+/* HeuristicLab
+ * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+
+#endregion
+
+using System;
+
+namespace HeuristicLab.Visualization.ChartControlsExtensions {
+  public static class ChartUtil {
+    public static void CalculateAxisInterval(double min, double max, int ticks, out double axisMin, out double axisMax, out double axisInterval) {
+      var dmin = min.Decimals();
+      axisMin = min.Floor(dmin);
+      var range = max - axisMin;
+      var slice = range / ticks;
+      var dslice = slice.Decimals();
+      var floor = slice.Floor(dslice);
+      var ceil = slice.Ceil(dslice);
+      var axisRange = floor * ticks;
+      axisInterval = floor;
+      if (axisRange < max - axisMin) {
+        axisRange = ceil * ticks;
+        axisInterval = ceil;
+      }
+      axisMax = axisMin + axisRange;
+    }
+
+    private static int Decimals(this double x) {
+      if (double.IsInfinity(x) || double.IsNaN(x))
+        return 0;
+
+      var v = Math.Abs(x);
+      int d = 0;
+      while (v < 1) {
+        v *= 10;
+        d++;
+      }
+      return d;
+    }
+
+    // rounds down to the nearest value according to the given number of decimal precision
+    private static double Floor(this double value, int precision) {
+      var n = Math.Pow(10, precision);
+      return Math.Round(Math.Floor(value * n) / n, precision);
+    }
+
+    private static double Ceil(this double value, int precision) {
+      var n = Math.Pow(10, precision);
+      return Math.Round(Math.Ceiling(value * n) / n, precision);
+    }
+
+    private static double Round(this double value, int precision) {
+      var n = Math.Pow(10, precision);
+      return Math.Round(Math.Round(value * n) / n, precision);
+    }
+  }
+}